# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic

from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .change_file_operation_operation import ChangeFileOperationOperation


class ChangeFileOperation(UniversalBaseModel):
    """
    ChangeFileOperation for creating, updating or deleting a file
    """

    content: typing.Optional[str] = pydantic.Field(default=None)
    """
    new or updated file content, must be base64 encoded
    """

    from_path: typing.Optional[str] = pydantic.Field(default=None)
    """
    old path of the file to move
    """

    operation: ChangeFileOperationOperation = pydantic.Field()
    """
    indicates what to do with the file
    """

    path: str = pydantic.Field()
    """
    path to the existing or new file
    """

    sha: typing.Optional[str] = pydantic.Field(default=None)
    """
    sha is the SHA for the file that already exists, required for update or delete
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(
            extra="allow", frozen=True
        )  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
