# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .attachment import Attachment
from .label import Label
from .milestone import Milestone
from .pull_request_meta import PullRequestMeta
from .repository_meta import RepositoryMeta
from .state_type import StateType
from .user import User


class Issue(UniversalBaseModel):
    """
    Issue represents an issue in a repository
    """

    assets: typing.Optional[typing.List[Attachment]] = None
    assignee: typing.Optional[User] = None
    assignees: typing.Optional[typing.List[User]] = None
    body: typing.Optional[str] = None
    closed_at: typing.Optional[dt.datetime] = None
    comments: typing.Optional[int] = None
    created_at: typing.Optional[dt.datetime] = None
    due_date: typing.Optional[dt.datetime] = None
    html_url: typing.Optional[str] = None
    id: typing.Optional[int] = None
    is_locked: typing.Optional[bool] = None
    labels: typing.Optional[typing.List[Label]] = None
    milestone: typing.Optional[Milestone] = None
    number: typing.Optional[int] = None
    original_author: typing.Optional[str] = None
    original_author_id: typing.Optional[int] = None
    pin_order: typing.Optional[int] = None
    pull_request: typing.Optional[PullRequestMeta] = None
    ref: typing.Optional[str] = None
    repository: typing.Optional[RepositoryMeta] = None
    state: typing.Optional[StateType] = None
    title: typing.Optional[str] = None
    updated_at: typing.Optional[dt.datetime] = None
    url: typing.Optional[str] = None
    user: typing.Optional[User] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(
            extra="allow", frozen=True
        )  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
