# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .label import Label
from .milestone import Milestone
from .pr_branch_info import PrBranchInfo
from .repository import Repository
from .state_type import StateType
from .team import Team
from .user import User


class PullRequest(UniversalBaseModel):
    """
    PullRequest represents a pull request
    """

    additions: typing.Optional[int] = None
    allow_maintainer_edit: typing.Optional[bool] = None
    assignee: typing.Optional[User] = None
    assignees: typing.Optional[typing.List[User]] = None
    base: typing.Optional[PrBranchInfo] = None
    body: typing.Optional[str] = None
    changed_files: typing.Optional[int] = None
    closed_at: typing.Optional[dt.datetime] = None
    comments: typing.Optional[int] = None
    created_at: typing.Optional[dt.datetime] = None
    deletions: typing.Optional[int] = None
    diff_url: typing.Optional[str] = None
    draft: typing.Optional[bool] = None
    due_date: typing.Optional[dt.datetime] = None
    head: typing.Optional[PrBranchInfo] = None
    html_url: typing.Optional[str] = None
    id: typing.Optional[int] = None
    is_locked: typing.Optional[bool] = None
    labels: typing.Optional[typing.List[Label]] = None
    merge_base: typing.Optional[str] = None
    merge_commit_sha: typing.Optional[str] = None
    mergeable: typing.Optional[bool] = None
    merged: typing.Optional[bool] = None
    merged_at: typing.Optional[dt.datetime] = None
    merged_by: typing.Optional[User] = None
    milestone: typing.Optional[Milestone] = None
    number: typing.Optional[int] = None
    patch_url: typing.Optional[str] = None
    pin_order: typing.Optional[int] = None
    requested_reviewers: typing.Optional[typing.List[User]] = None
    requested_reviewers_teams: typing.Optional[typing.List[Team]] = None
    review_comments: typing.Optional[int] = pydantic.Field(default=None)
    """
    number of review comments made on the diff of a PR review (not including comments on commits or issues in a PR)
    """

    state: typing.Optional[StateType] = None
    title: typing.Optional[str] = None
    updated_at: typing.Optional[dt.datetime] = None
    url: typing.Optional[str] = None
    user: typing.Optional[User] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(
            extra="allow", frozen=True
        )  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
