# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .attachment import Attachment
from .tag_archive_download_count import TagArchiveDownloadCount
from .user import User


class Release(UniversalBaseModel):
    """
    Release represents a repository release
    """

    archive_download_count: typing.Optional[TagArchiveDownloadCount] = None
    assets: typing.Optional[typing.List[Attachment]] = None
    author: typing.Optional[User] = None
    body: typing.Optional[str] = None
    created_at: typing.Optional[dt.datetime] = None
    draft: typing.Optional[bool] = None
    hide_archive_links: typing.Optional[bool] = None
    html_url: typing.Optional[str] = None
    id: typing.Optional[int] = None
    name: typing.Optional[str] = None
    prerelease: typing.Optional[bool] = None
    published_at: typing.Optional[dt.datetime] = None
    tag_name: typing.Optional[str] = None
    tarball_url: typing.Optional[str] = None
    target_commitish: typing.Optional[str] = None
    upload_url: typing.Optional[str] = None
    url: typing.Optional[str] = None
    zipball_url: typing.Optional[str] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(
            extra="allow", frozen=True
        )  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
